"""PHP-style authorisation functions.

Version:

    File Version 0.1 for LEMON 0.2
    
Usage:

    session = lemon.session.SessionDB(cursor, appName)  # Retrieve the session or create a new one
    auth    = lemon.auth.AuthDB(session)                # Create auth object from the session information
    
    if auth.isValid():                                  # See if the User is logged on else present login form.
        user = a.getUser()                              # Return a user object containing user's details.
        user.Password                                   # Access the data via attributes or dict style.
        user.getStatus()                                # Retrieve the entry for the appName column.

ToDO:

    addUser, RemoveUser etc.
    gadfly
    create the database if not already there?? 
    definately need config file similar to php.ini
"""

__author__ = "James Gardner [email: james at xecos.com]"
__date__ = "02 July 2003"
__version__ = "Version 0.1 for LEMON 0.2"[-3:]
__credits__ = "Guido van Rossum, for an excellent programming language."

import drivers.db

def start(storage, database=None):
    "The preffered method to start the auth classes."

    if storage == 'db':
        if not database:
            raise Exception("You must specify a database connection to use the 'db' storage driver.")
        else:
            return drivers.db.DB(database)
    else:
        raise AuthError("No driver named '%s' found."%storage)
    